<%@ Page Language="VB" AutoEventWireup="false" Inherits="Westination.SQLInjectionShield.Licensing.LicenseInfo_aspx" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Shield Information</title>
    <meta http-equiv="x-ua-compatible" content="IE=edge" />
</head>
<body>
    <form id="frmMain" runat="server">
        <asp:HiddenField ID="Selection" runat="server" />
        <asp:HiddenField ID="Nickname" runat="server" />
        <asp:Panel ID="pnlLicenseState" runat="server" />
        <asp:Panel ID="pnlAuthenticate" runat="server" CssClass="centered">
            <p class="taCenter">Already purchased one or more shields? Enter your email address and password to view your existing shields.</p>
            <asp:Table ID="tblAuthenticate" runat="server" HorizontalAlign="Center" CellPadding="0" CellSpacing="0">
                <asp:TableRow>
                    <asp:TableCell ID="valEmailAddress" runat="server" CssClass="tdValidation" ColumnSpan="2" />
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell CssClass="RowHeader">Email Address:</asp:TableCell>
                    <asp:TableCell CssClass="vaMiddle"><asp:TextBox ID="txtEmailAddress" runat="server" CssClass="TextBox" /></asp:TableCell>
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell ID="valPassword" runat="server" CssClass="tdValidation" ColumnSpan="2" />
                </asp:TableRow>
                <asp:TableRow>
                    <asp:TableCell CssClass="RowHeader">Password:</asp:TableCell>
                    <asp:TableCell CssClass="vaMiddle"><asp:TextBox ID="txtPassword" runat="server" CssClass="TextBox" /></asp:TableCell>
                </asp:TableRow>
            </asp:Table>
        </asp:Panel>
        <asp:Panel ID="pnlEventButtons" runat="server" CssClass="centered">
            <asp:Literal ID="litSimpleInstructions" runat="server" />
            <asp:Table ID="tblEventButtons" runat="server" HorizontalAlign="center" CellPadding="0" CellSpacing="0" style="margin-top:12px;">
                <asp:TableRow>
                    <asp:TableCell CssClass="vaMiddle"><asp:Button ID="btnViewLicenses" runat="server" CssClass="Button" Text="View Existing Shields" /></asp:TableCell>
                    <asp:TableCell CssClass="vaMiddle taCenter" style="padding:0 4px 0 4px;">or</asp:TableCell>
                    <asp:TableCell CssClass="vaMiddle"><asp:Button ID="btnPurchaseLicenses" runat="server" CssClass="Button" Text="Purchase New Shields" /></asp:TableCell>
                </asp:TableRow>
            </asp:Table>
        </asp:Panel>
        <asp:Panel ID="pnlAvailableLicenses" runat="server" CssClass="centered">
            <asp:Table ID="tblAvailableLicenses" runat="server" HorizontalAlign="center" CellPadding="4" CellSpacing="0" />
            <asp:Panel ID="pnlBindLicense" runat="server" HorizontalAlign="right"><asp:Button ID="btnBindLicense" runat="server" CssClass="Button" Text="Activate Shield" Enabled="false" /></asp:Panel>
        </asp:Panel>
        <asp:Panel ID="pnlInstructions" runat="server" style="margin:2em 2em 2em 2em; display:block;">
            <div class="centered">
                <div id="ConfigGuide" class="centered"><h3 style="cursor:pointer; white-space:nowrap;" title="click to show/hide"><span class="winc-icon winc-icon-arrow-e"></span>Configuration Guide</h3></div>
                <div class="ui-helper-hidden" style="padding:0 0 0 18px; max-width:1292px;">
                    <h3 style="margin-bottom:4px;">Enable SQL Injection Shield&trade; via your web.config file:</h3>
                    <div id="WebConfigEntries">
                        <ul>
                            <li><a href="#AttackMonitoring">Attack Monitoring</a></li>
                            <li><a href="#EmailNotification">Attack Notification</a></li>
                            <li><a href="#AdvancedOptions">Advanced Options</a></li>
                        </ul>
                        <div id="AttackMonitoring" style="overflow:auto;">
                            <p>To enable attack monitoring, the specific web.config entry depends upon which IIS <a class="rollover" content="#ManagedPipelineMode" href="http://www.iis.net/learn/application-frameworks/building-and-running-aspnet-applications/aspnet-integration-with-iis" target="_blank">Managed Pipeline Mode</a> is enabled on your website. This website is using "<asp:Label ID="lblPipelineMode" runat="server" CssClass="highlight bold" />" mode. Follow the instructions for <asp:Literal ID="litPipelineMode" runat="server" /> pipeline mode, as illustrated below.</p>
                            <div id="ManagedPipelineMode" class="rollover-content">
                                <div class="rollover-content-root" style="font-size:.8em;">
                                    <p>In IIS 7 and beyond, each application pool uses one of two .NET integration modes for running ASP.NET applications: "Integrated" or "Classic".</p>
                                    <p>Integrated mode allows ASP.NET modules to participate in IIS request processing, regardless of the type of resource requested.</p>
                                    <p class="mb0">With classic mode (IIS 6), requests are initially processed through IIS modules, and then ASP.NET requests are separately processed via the aspnet_isapi.dll.</p>
                                </div>
                            </div>
                            <div id="ConfigModes" style="margin:0 0 14px 0;">
                                <h3>Classic Pipeline</h3>
                                <div>
                                    <p>Add the highlighted entry to the <span class="TagNames">configuration</span><span class="TagValues">/</span><span class="TagNames">system.web</span><span class="TagValues">/</span><span class="TagNames">httpModules</span> section of your web.config file, as illustrated in the snapshot below. If your web.config file doesn't have an <span class="TagValues">&lt;</span><span class="TagNames">httpModules</span><span class="TagValues">&gt;</span> section within <span class="TagValues">&lt;</span><span class="TagNames">system.web</span><span class="TagValues">&gt;</span>, then add it along with the highlighted portion.</p>
                                    <pre>
<span class="TagValues">&lt;</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;</span><span class="TagNames">system.web</span><span class="TagValues">&gt;</span>
        <span class="TagValues">&lt;</span><span class="TagNames">httpModules</span><span class="TagValues">&gt;</span>
            <span style="background-color:#FAF8A2; padding:3px 5px 3px 5px;"><span class="TagValues">&lt;</span><span class="TagNames">add</span> <span class="TagAttributes">name</span><span class="TagValues">="Westination.SQLInjectionShield"</span> <span class="TagAttributes">type</span><span class="TagValues">="Westination.Web.SQLInjectionShield"/&gt;</span></span>
        <span class="TagValues">&lt;/</span><span class="TagNames">httpModules</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;/</span><span class="TagNames">system.web</span><span class="TagValues">&gt;</span>
<span class="TagValues">&lt;/</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
                                    </pre>
                                </div>
                                <h3>Integrated Pipeline</h3>
                                <div>
                                    <p>Add the highlighted entry to the <span class="TagNames">configuration</span><span class="TagValues">/</span><span class="TagNames">system.webServer</span><span class="TagValues">/</span><span class="TagNames">modules</span> section of your web.config file, as illustrated in the snapshot below. If your web.config file doesn't have a <span class="TagValues">&lt;</span><span class="TagNames">modules</span><span class="TagValues">&gt;</span> section within <span class="TagValues">&lt;</span><span class="TagNames">system.webServer</span><span class="TagValues">&gt;</span>, then add it along with the highlighted portion.</p>
                                    <pre>
<span class="TagValues">&lt;</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;</span><span class="TagNames">system.webServer</span><span class="TagValues">&gt;</span>
        <span class="TagValues">&lt;</span><span class="TagNames">modules</span><span class="TagValues">&gt;</span>
            <span style="background-color:#FAF8A2; padding:3px 5px 3px 5px;"><span class="TagValues">&lt;</span><span class="TagNames">add</span> <span class="TagAttributes">name</span><span class="TagValues">="Westination.SQLInjectionShield"</span> <span class="TagAttributes">type</span><span class="TagValues">="Westination.Web.SQLInjectionShield"</span> <span class="TagAttributes">preCondition</span><span class="TagValues">="integratedMode,managedHandler"/&gt;</span></span>
        <span class="TagValues">&lt;/</span><span class="TagNames">modules</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;/</span><span class="TagNames">system.webServer</span><span class="TagValues">&gt;</span>
<span class="TagValues">&lt;/</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
                                    </pre>
                                </div>
                            </div>
                            <h3 class="fs16px cufon" style="color:#000000;">How to Toggle On &amp; Off</h3>
                            <p>Commenting out or removing the highlighted element within the <span class="TagValues">&lt;</span><span class="TagNames">httpModules</span><span class="TagValues">&gt;</span> or <span class="TagValues">&lt;</span><span class="TagNames">modules</span><span class="TagValues">&gt;</span> section (as defined in your above choice), disables attack monitoring. In this fashion, you can quickly toggle between enabled and disabled states, without having to remove the uploaded files or having to modify any other web.config entries.</p>
                            <h3 class="fs16px cufon" style="color:#000000;">How Do I know It's Working?</h3>
                            <p class="mb3">The only way to know for sure is to attack yourself. Append the following query string to the end of a page link on your website.</p>
                            <p class="bold" style="margin:0 0 4px 24px;">?test=1 or null is null</p>
                            <p style="margin:0 0 12px 24px;">Example: <span style="color:#000000;">http://<span class="highlight">your-website</span>/default.aspx<b>?test=1 or null is null</b></span></p>
                            <p>If installed correctly, you should see a corresponding "FailureAudit.html" event file within the <span class="mono" style="font-size:1.2em;">./Westination/SQLInjectionShield/EventLog/</span> folder. If you enabled email notifications (next tab), then you should receive a corresponding email alert as well.</p>
                            <p>In case you're wondering, the term "FailureAudit" means that the request failed the safety audit.</p>
                        </div>
                        <div id="EmailNotification" style="overflow:auto;">
                            <p class="mb3">Attack events are logged to the <span class="mono" style="font-size:1.2em;">./Westination/SQLInjectionShield/EventLog/</span> folder.</p>
                            <p class="mb3">SQL Injection Shield&trade; will also send reports, via email, to the recipient(s) defined in the <span class="TagNames">configuration</span><span class="TagValues">/</span><span class="TagNames">appSettings</span> section highlighted below. In order to receive attack notification emails, it is important that your outgoing mail server is correctly defined within the <span class="TagNames">system.net</span><span class="TagValues">/</span><span class="TagNames">mailSettings</span> section, as illustrated below.</p>
                            <p>To enable email notifications, add the following highlighted entries to your web.config file.</p>
                            <pre>
<span class="TagValues">&lt;</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;</span><span class="TagNames">appSettings</span><span class="TagValues">&gt;</span>
            <span style="background-color:#FAF8A2; padding:3px 5px 3px 5px;"><span class="TagValues">&lt;</span><span class="TagNames">add</span> <span class="TagAttributes">key</span><span class="TagValues">="Westination.SQLInjectionShield.Email.Recipients"</span> <span class="TagAttributes">value</span><span class="TagValues">="email@your-domain;next.email@your-domain"/&gt;</span></span>
    <span class="TagValues">&lt;/</span><span class="TagNames">appSettings</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;</span><span class="TagNames">system.net</span><span class="TagValues">&gt;</span>
        <span class="TagValues">&lt;</span><span class="TagNames">mailSettings</span><span class="TagValues">&gt;</span>
            <span style="color:#007D00; font-family:'Courier New';">&lt;!-- smtp from = the address that will appear as the sender of the email. --&gt;</span>
            <span class="TagValues">&lt;</span><span class="TagNames">smtp</span> <span class="TagAttributes">from</span><span class="TagValues">="automation@westination.com"&gt;</span>
                <span style="color:#007D00; font-family:'Courier New';">&lt;!-- network host = your outgoing SMTP mail server. --&gt;</span>
                <span style="background-color:#FAF8A2; padding:3px 5px 3px 5px;"><span class="TagValues">&lt;</span><span class="TagNames">network</span> <span class="TagAttributes">host</span><span class="TagValues">="your-mail-server"</span> <span class="TagAttributes">port</span><span class="TagValues">="25"</span> <span class="TagAttributes">userName</span><span class="TagValues">=""</span> <span class="TagAttributes">password</span><span class="TagValues">=""/&gt;</span></span>
            <span class="TagValues">&lt;/</span><span class="TagNames">smtp</span><span class="TagValues">&gt;</span>
        <span class="TagValues">&lt;/</span><span class="TagNames">mailSettings</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;/</span><span class="TagNames">system.net</span><span class="TagValues">&gt;</span>
<span class="TagValues">&lt;/</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
                            </pre>
                            <p class="mb4 bold fsEmP4">Troubleshooting:</p>
                            <p class="mb3">If you're not receiving emails, then check the EventLog folder. If the event is logged there, then there is a problem with the email settings defined above.</p>
                            <table>
                                <tbody>
                                    <tr>
                                        <td style="padding:0 4px 8px 24px;">1.</td><td>Does the specified mail server allow sending from your website?</td>
                                    </tr>
                                    <tr>
                                        <td style="padding: 0 4px 8px 24px;">2.</td><td>Is the specified port correct?</td>
                                    </tr>
                                    <tr>
                                        <td style="padding: 0 4px 8px 24px;">3.</td><td>Is the specified username and password correct?</td>
                                    </tr>
                                    <tr>
                                        <td style="padding: 0 4px 8px 24px;">4.</td><td>If your web server is also your mail server, then try specifying 127.0.0.1 as your host.</td>
                                    </tr>
                                    <tr>
                                        <td style="padding: 0 4px 16px 24px;">5.</td><td>Did you check your spam folder?</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div id="AdvancedOptions" style="overflow:auto;">
                            <p>By default, SQL Injection Shield monitors all the standard ASP.Net page types that receive and process input (.aspx .ashx .asmx, etc.) However, there may be cases when one would want to either extend or override the default monitoring. For example:</p>
                            <p>What if you have a custom page handler installed on your website that accepts input from non-standard pages, and you want SQL Injection Shield to monitor those as well?</p>
                            <p>Or, what if you need to exclude a page or folder from being monitored for some reason? E.g. you have a secure webpage that allows privileged employees to execute ad-hoc SQL queries to your database.</p>
                            <p>The web.config entries, illustrated below, are based on the following example scenarios.</p>
                            <table>
                                <tbody>
                                    <tr>
                                        <td class="pl9 pr1 pb3">1.</td><td>You have installed a custom page handler that enables your website to respond to requests for pages with a .custom extension, and you want SQL Injection Shield to monitor and protect your .custom pages.</td>
                                    </tr>
                                    <tr>
                                        <td class="pl9 pr1">2.</td><td>You have a secure folder on your website, named http://your-website/secure/ad-hoc/, which allows privileged employees to execute ad-hoc SQL queries to your database, and you want to disable monitoring on pages within that folder.</td>
                                    </tr>
                                </tbody>
                            </table>
                            <pre>
<span class="TagValues">&lt;</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
    <span class="TagValues">&lt;</span><span class="TagNames">appSettings</span><span class="TagValues">&gt;</span>
            <span style="background-color:#FAF8A2; padding:3px 5px 3px 5px;"><span class="TagValues">&lt;</span><span class="TagNames">add</span> <span class="TagAttributes">key</span><span class="TagValues">="Westination.SQLInjectionShield.PageProtection.Additions"</span> <span class="TagAttributes">value</span><span class="TagValues">="*.custom"/&gt;</span></span>
            <span style="background-color:#FAF8A2; padding:3px 5px 3px 5px;"><span class="TagValues">&lt;</span><span class="TagNames">add</span> <span class="TagAttributes">key</span><span class="TagValues">="Westination.SQLInjectionShield.PageProtection.Exclusions"</span> <span class="TagAttributes">value</span><span class="TagValues">="/secure/ad-hoc/*"/&gt;</span></span>
    <span class="TagValues">&lt;/</span><span class="TagNames">appSettings</span><span class="TagValues">&gt;</span>
<span class="TagValues">&lt;/</span><span class="TagNames">configuration</span><span class="TagValues">&gt;</span>
                            </pre>
                            <p>The * character is a wildcard symbol, therefore the extensions .custom1 and .custom2 can be represented by a single *.custom* entry.</p>
                            <p>If you have multiple additions or exclusions, separate them with the | character. For example:  *.abc|*.xyz</p>
                        </div>
                    </div>
                </div>
            </div>
            <script type="text/javascript">//<![CDATA[
                jQuery('#ConfigGuide').bind('click',
                    function(){
                        var guideLink = jQuery(this);
                        guideLink.find('span.winc-icon').toggleClass('winc-icon-arrow-e winc-icon-arrow-se').parent().parent().next().toggle('blind', {direction:'up'},
                            function(){
                                jQuery.smoothScroll({'scrollTarget': '#ConfigGuide'});
                            }
                        );
                        
                    }
                );
            //]]></script>
        </asp:Panel>
        <asp:Panel ID="pnlNickname" runat="server" style="display:none;">
            <asp:Literal ID="litNicknamePrompt" runat="server" />
            <asp:Panel ID="pnlNicknameAlert" runat="server" CssClass="ui-state-error ui-corner-all" style="padding: 0em; display:none;">
                <p style="margin:.2em;"><span class="ui-icon ui-icon-alert" style="float: left; margin-right: 0.3em;"></span> Nickname is required.</p>
            </asp:Panel>
            <p style="text-align:center;"><asp:TextBox ID="txtNickname" runat="server" /></p>
        </asp:Panel>
<div id="ClientDialog" class="ui-helper-hidden">
<asp:Literal ID="WINC_ClientDialog" runat="server" />
</div>
    </form>
</body>
</html>
